local AI_LastRequest;
local AI_LastStatus;
local AI_Redirecting;
local AI_RedirectTo;
local AI_RedirSpam;
local AI_LastBuff;
local DAlive;
local DInnerv;
local DBRez;
local Druids;
local StatusTimer;
local InnStatus;
local BRezStatus;
local LifeStatus;
InnerID=0;
RebirthID=0;
local TotalDruids;
local VariablesLoaded;
AIStatusEnable=0;
local AI_INNERVATE_NAME;
local AI_REBIRTH_NAME;
local AI_MARK_NAME;
local ViewOnly;


--Saved Variables
AIEnabled=1;
AIEnablePriest=0;
AIEnableMage=0;
AIEnableWarlock=0;
AIEnableShaman=0;
AIEnableDruid=0;
AIEnableHunter=0;
AIChatChannel="druidchat";
AISpamDelay=5;
TargetMinMana=2500;
AIRaidOnly=1;
AIAutoBuff=1;
AIOutputRaid=1;
AIOutputChannel=0;
AIDebugEnabled=false;

--Constants
AIEnablePriestName="Priest";
AIEnableMageName="Mage";
AIEnableWarlockName="Warlock";
AIEnableShamanName="Shaman";
AIEnableDruidName="Druid";
AIEnableHunterName="Paladin";
AIInnervateTrigger="innervate";
AIVersion="2.44";
BINDING_NAME_ARIOPTIONS="Options";
BINDING_NAME_ARISINNERVATE="Smart Innervate";
BINDING_NAME_ARISTATUS="Toggle Status Window";
BINDING_HEADER_ADUNEINNERVATE="Adune's Raid Innervate";

--Init Function
function ImpInnervate()

 DEFAULT_CHAT_FRAME:AddMessage("Adune's Improved Innervate "..AIVersion.." loaded.");
 DEFAULT_CHAT_FRAME:AddMessage("Use /aio for options");
 SLASH_SINNERVATE1="/sinnervate";
 SLASH_AIOPTIONS1="/aio";
 SlashCmdList["SINNERVATE"]= SmartInnervate;
 SlashCmdList["AIOPTIONS"]= AIOptions;
 this:RegisterEvent("CHAT_MSG_ADDON");
 --this:RegisterEvent("RAID_ROSTER_UPDATE");
 this:RegisterEvent("PARTY_MEMBERS_CHANGED");
 this:RegisterEvent("CHAT_MSG_WHISPER");
 this:RegisterEvent("CHAT_MSG_SYSTEM");
 this:RegisterEvent("SPELLS_CHANGED");
  --Initialize anti-spam values
	StatusTimer=GetTime();
	VariablesLoaded=false;
	AIStatusEnable=0;
	
	AI_LastRequest=0;
	AI_LastStatus=0;
	AI_Redirecting=false;
	AI_RedirectTo=nil;
	AI_RedirSpam=0;
	AI_LastBuff=0;
	DAlive={};
	DInnerv={};
	DBRez={};
	Druids={};
	StatusTimer=0;
	InnStatus=nil;
	BRezStatus=nil;
	LifeStatus=nil;
	InnerID=nil;
	RebirthID=nil;
	TotalDruids=0;
	AI_RedirSpamB=0;
	
	if ( GetLocale() == "deDE" ) then
		AI_INNERVATE_NAME="Anregen";
		AI_REBIRTH_NAME="Wiedergeburt";
		AI_MARK_NAME="Mal der Wildnis";
		AIEnablePriestName="Priester";
		AIEnableMageName="Magier";
		AIEnableWarlockName="Hexenmeister";
		AIEnableShamanName="Schamane";
		AIEnableDruidName="Druide";
		AIEnableHunterName="Paladin";
		AIInnervateTrigger="anregen";		
	elseif ( GetLocale() =="frFR" ) then
		AI_INNERVATE_NAME="Innervation";
		AI_REBIRTH_NAME="Renaissance";
		AI_MARK_NAME="Marque du fauve";
		AIEnablePriestName="Pr\195\170tre";
		AIEnableMageName="Mage";
		AIEnableWarlockName="D\195\169moniste";
		AIEnableShamanName="Chaman";
		AIEnableDruidName="Druide";
		AIEnableHunterName="Paladin";
		AIInnervateTrigger="innervation";
	else
		AI_INNERVATE_NAME="Innervate";
		AI_REBIRTH_NAME="Rebirth";
		AI_MARK_NAME="Mark of the Wild";
		AIEnablePriestName="Priest";
		AIEnableMageName="Mage";
		AIEnableWarlockName="Warlock";
		AIEnableShamanName="Shaman";
		AIEnableDruidName="Druid";
		AIEnableHunterName="Paladin";
		AIInnervateTrigger="innervate";
	end
 --Init popup messages
 StaticPopupDialogs["Innervate_Confirm"]=
{
	text="Do you want to innervate %s?",
	button1="Yes", 
	button2="No",
	OnAccept=function(Sender)
		AutoInnervate(Sender);
	end,
	OnCancel=function(Sender)
		DeclineInnervate(Sender);
	end,
	sound="levelup2",
	timeout=0,
	whileDead=1,
	hideOnEscape=1
};

 StaticPopupDialogs["Raid_Innervate_Confirm"]=
{
	text="Do you want to innervate %s?",
	button1="Yes", 
	button2="No",
	OnAccept=function(Sender)
		AutoInnervateRaid(Sender);
	end,
	OnCancel=function(Sender)
		DeclineInnervate(Sender);
	end,
	sound="levelup2",
	timeout=0,
	whileDead=1,
	hideOnEscape=1
};

StaticPopupDialogs["Buff_Confirm"]=
{
	text="Cast %s on %s?",
	button1="Yes", 
	button2="No",
	OnAccept=function()
		CastSpellByName(AI_MARK_NAME);
		TargetLastTarget();
	end,
	OnCancel=function(plr)
		SendChatMessage("Buff request DENIED!","WHISPER",nil,plr);
	end,
	sound="levelup2",
	timeout=10,
	whileDead=1,
	hideOnEscape=1
};
end

function AIStatusToggle()
	if (AIStatusEnable==1) then
		AIStatusEnable=0;
		AIFrame:Hide();
	else
		AIStatusEnable=1;
		AIFrame:Show();
	end
end

function AISay(Text)
	if (AIDebugEnabled==true) then
		WriteLine(Text);
	end
end

function AIDebugToggle()
	if AIDebugEnabled==true then
		AIDebugEnabled=false;
		WriteLine("Debug mode enabled!");
	else
		AIDebugEnabled=true;
		WriteLine("Debug mode enabled!");
	end
end

function AI_FindDruid(DruidName)
	for i=1,TotalDruids do
		if (Druids[i]==DruidName) then
			return i
		end
	end
	return 0;
end

function FormatTime(tRemain)
	if tRemain<60 then
		if tRemain>10 then
			return "0:"..string.format("%.0f",tRemain);
		else
			return "0:0"..string.format("%.0f",tRemain);
		end
	else
		local minutes=string.format("%.0f",math.floor(tRemain/60));
		local seconds=tRemain-(minutes*60);
		if seconds<10 then
			seconds="0"..string.format("%.0f",seconds);
		else
			seconds=string.format("%.0f",seconds);
		end
		return minutes..":"..seconds;
	end
end

function AI_InnervateUp()
	local SStart, SEnd=GetSpellCooldown(InnerID, "SPELL");
	local TimeRemain=SEnd-(GetTime()-SStart);
	if (SStart~=0 and TimeRemain>2) then
		
		return FormatTime(TimeRemain);
	else
		return "UP";
	end
end

--local BRezStatus;
function AI_BRezUp()
	local SStart, SEnd=GetSpellCooldown(RebirthID, "SPELL");
	local TimeRemain=SEnd-(GetTime()-SStart);
	if (TimeRemain>2) then
		return FormatTime(TimeRemain);
	else
		return "UP";
	end
end
--local LifeStatus;
function AI_IsAlive()
	if (UnitIsDeadOrGhost("player")==nil) then
		return "A";
	else
		return "D";
	end
end

function ShowBuffs()
	local i=1;
	local buff;
	buff=UnitBuff("target",i);
	while (buff~=nil) do
		WriteLine("Buff "..i..":"..buff);
		i=i+1;
		buff=UnitBuff("player",i);
	end
end

function AIOptions()
	AIOptions_Show();
end

function AI_SafeText(Value)
	if (Value) then
		return Value;
	else
		return " ";
	end
end

function ListDruids()
	WriteLine("Status Enabled:'"..AIStatusEnable.."'");
end

function AI_UpdateStatusFrame()
	for i=1, 8 do
		getglobal("AIFrameName"..i):SetText(Druids[i]);
		if (DAlive[i]=="A") then 
			getglobal("AIFrameName"..i):SetVertexColor(0,.9,0);
		elseif (DAlive[i]=="D") then
			getglobal("AIFrameName"..i):SetVertexColor(.9,0,0);
		end
		getglobal("AIFrameInnerv"..i):SetText(DInnerv[i]);
		if (DInnerv[i]~="UP") then
			getglobal("AIFrameInnerv"..i):SetVertexColor(.9,0,0);
		else
			getglobal("AIFrameInnerv"..i):SetVertexColor(0,.9,0);
		end
		getglobal("AIFrameBRez"..i):SetText(DBRez[i]);
		if (DBRez[i]~="UP") then
			getglobal("AIFrameBRez"..i):SetVertexColor(.9,0,0);
		else
			getglobal("AIFrameBRez"..i):SetVertexColor(0,.9,0);
		end
	end
end

function AI_UpdateInnervate(Player, Value)
	Druids[Player].Innervate=Value;
end

function AI_Alert(Message)
	if (AIOutputRaid==1) then
		SendChatMessage("***"..Message.."***","RAID",nil);
	end
	if (AIOutputChannel==1) then
		SendChatMessage("***"..Message.."***","CHANNEL",nil,GetChannelName(AIChatChannel));
	end
end

function AI_InitVariables()
	InnerID=GetSpellID(AI_INNERVATE_NAME);
	AISay("Innervate stored as Spell ID:"..InnerID);
	RebirthID=GetSpellID(AI_REBIRTH_NAME);
	AISay("Rebirth stored as Spell ID:"..RebirthID);
	SendAddonMessage("ARI","DSSYNC", "RAID");
	
	if (RebirthID==0 or InnerID==0) then
		WriteLine("Innervate or Rebirth not found!");
	else
		VariablesLoaded=true;
	end
end

function AI_OnEvent()

	if (event=="SPELLS_CHANGED" and UnitClass("player")==AIEnableDruidName) then
		AI_InitVariables();
	end
	
  if (VariablesLoaded~=true) then
	if (strsub(event,1,14)=="CHAT_MSG_ADDON" and arg1=="ARI") then
		--WriteLine("ARG1:"..arg1.."Arg2:"..arg2.."Arg3"..arg3);
		local i;
		if (strsub(arg2,1,5)=="UPIN:") then
			i=AI_FindDruid(arg4);
			if (i>0) then
				DInnerv[i]=strsub(arg2, 6);
			else
				TotalDruids=TotalDruids+1;
				Druids[TotalDruids]=arg4;
				DInnerv[TotalDruids]=strsub(arg2, 6);
			end
		elseif (strsub(arg2,1,5)=="UPBR:") then
			i=AI_FindDruid(arg4);
			if (i>0) then
				DBRez[i]=strsub(arg2, 6);
			else
				TotalDruids=TotalDruids+1;
				Druids[TotalDruids]=arg4;
				DBRez[TotalDruids]=strsub(arg2, 6);
			end
		elseif (strsub(arg2,1,5)=="UPPL:") then
			i=AI_FindDruid(arg4);
			if (i>0) then
				DAlive[i]=strsub(arg2, 6);
			else
				TotalDruids=TotalDruids+1;
				Druids[TotalDruids]=arg4;
				DAlive[TotalDruids]=strsub(arg2, 6);
			end
		end
		AI_UpdateStatusFrame();
	end

  else
	
	if (AIEnabled==1) and (strsub(event,1)=="CHAT_MSG_ADDON" and arg1=="ARI") then
		if (arg2=="REQREDIRECT") then
			AISay("ReqRedirect detected");
			if ((GetTime()-AI_RedirSpam)>2) then
				AI_RedirSpam=GetTime();
				if LifeStatus=="A" then
					local SStart, SEnd=GetSpellCooldown(InnerID, "SPELL");
					local TimeRemain=SEnd-(GetTime()-SStart);
					if (SStart==0 or TimeRemain<2) then
						SendAddonMessage("ARI","REQREDIRECTYES", "RAID");
					end
				else
					--WriteLine("Redirect--AliveStatus"..LifeStatus);
				end				
			end
		end
	end
	
	if (AIEnabled==1) and (strsub(event,1)=="CHAT_MSG_ADDON" and arg1=="ARI") then
		if (AI_Redirecting and arg2=="REQREDIRECTYES") then
			AI_Redirecting=false;
			SendChatMessage("AUTOINN:"..AI_RedirectTo,"WHISPER",nil,arg4);
		end
	end
	
	if (strsub(event,1)=="CHAT_MSG_SYSTEM" and arg1=="You have joined a raid group") then
		AIStatusEnable=1;
		AIFrame:Show();
	end
	
	if (event=="CHAT_MSG_SYSTEM" and arg1=="You have left the raid group") then
		AIStatusEnable=0;
		AIFrame:Hide();
	end
	
	if (AIEnabled==1) and (strsub(event,1)=="CHAT_MSG_WHISPER") and arg2~=UnitName("player") then
		local msg=arg1;
		local plr=arg2;
		if (strsub(string.lower(msg),1,9)=="innervate" or strsub(string.lower(msg),1,9)==strsub(string.lower(msg),1,9)==AIInnervateTrigger) then
			AISay("Innervate Tell detected");
			if ((GetTime()-AI_LastRequest)>AISpamDelay) then
				AISay("Spam Delay OK");
				local PlayerRaidID=AIRaidID(plr)
				if (AIRaidOnly==1 and PlayerRaidID==nil) then
					--Do Nothing, they're not in the raid.
				else
					if LifeStatus=="D" then
						SendChatMessage("I'm dead!  AI_Redirecting...","WHISPER",nil,plr);
						SendAddonMessage("ARI","REQREDIRECT", "RAID");
						AI_Redirecting=true;
						AI_RedirectTo=plr;
						AI_RedirSpam=GetTime();
					else
						AISay("I am alive.");
						AI_LastRequest=GetTime();
						local SStart, SEnd=GetSpellCooldown(InnerID, "SPELL");
						local TimeRemain=SEnd-(GetTime()-SStart);
						if (SStart~=0 and TimeRemain>2) then
							SendChatMessage("Innervate is not up!  "..string.format("%.0f",TimeRemain).." seconds until it's up: Redirecting...","WHISPER",nil,plr);
							SendAddonMessage("ARI","REQREDIRECT", "RAID");
							AI_Redirecting=true;
							AI_RedirectTo=plr;
							AI_RedirSpam=GetTime();
						else
							if (AIRaidOnly==1) then
								if ((UnitClass("raid"..PlayerRaidID)==AIEnablePriestName) and AIEnablePriest==1) or ((UnitClass("raid"..PlayerRaidID)==AIEnableMageName) and AIEnableMage==1) or ((UnitClass("raid"..PlayerRaidID)==AIEnableWarlockName) and AIEnableWarlock==1) or ((UnitClass("raid"..PlayerRaidID)==AIEnableShamanName) and AIEnableShaman==1) or ((UnitClass("raid"..PlayerRaidID)==AIEnableDruidName) and AIEnableDruid==1)or ((UnitClass("raid"..PlayerRaidID)==AIEnableHunterName) and AIEnableHunter==1)then
									if (UnitMana("raid"..PlayerRaidID)>TargetMinMana) then
										SendChatMessage("You can only request an auto Innervate below "..TargetMinMana.." mana.","WHISPER",nil,plr);
									else
										AI_Alert(arg2.." has auto requested an Innervate.");
										local dialog = StaticPopup_Show("Raid_Innervate_Confirm", arg2);
										if (dialog) then
											dialog.data=arg2;
										end
									end
								end
							else
								AI_Alert(arg2.." has auto requested an Innervate.");
								local dialog = StaticPopup_Show("Innervate_Confirm", arg2);
								if (dialog) then
									dialog.data=arg2;
								end
							end--RaidOnly
						end--SpellonCooldown
					end--Player Dead/Alive
				end--RaidOnly
			end--SpamDelay
		end--Innervate tell
	end
	
	if (AIEnabled==1) and (event=="CHAT_MSG_WHISPER") then
	--*********************************************************************************************************
		local plr;
		--WriteLine("Event:"..event.."Arg1:"..arg1.."  Arg2:"..arg2);
		if (strsub(arg1,1,8)=="AUTOINN:") then
			plr=strsub(arg1,9);
			local dialog = StaticPopup_Show("Innervate_Confirm", plr);
			if (dialog) then
				dialog.data=plr;
			end
		end
	end
	
	if (strsub(event,1,14)=="CHAT_MSG_ADDON" and arg1=="ARI") then
		--WriteLine("ARG1:"..arg1.."Arg2:"..arg2.."Arg3"..arg3);
		local i;
		if (strsub(arg2,1,5)=="UPIN:") then
			i=AI_FindDruid(arg4);
			if (i>0) then
				DInnerv[i]=strsub(arg2, 6);
			else
				TotalDruids=TotalDruids+1;
				Druids[TotalDruids]=arg4;
				DInnerv[TotalDruids]=strsub(arg2, 6);
			end
		elseif (strsub(arg2,1,5)=="UPBR:") then
			i=AI_FindDruid(arg4);
			if (i>0) then
				DBRez[i]=strsub(arg2, 6);
			else
				TotalDruids=TotalDruids+1;
				Druids[TotalDruids]=arg4;
				DBRez[TotalDruids]=strsub(arg2, 6);
			end
		elseif (strsub(arg2,1,5)=="UPPL:") then
			i=AI_FindDruid(arg4);
			if (i>0) then
				DAlive[i]=strsub(arg2, 6);
			else
				TotalDruids=TotalDruids+1;
				Druids[TotalDruids]=arg4;
				DAlive[TotalDruids]=strsub(arg2, 6);
			end
		elseif (strsub(arg2,1)=="DSSYNC") then
			InnStatus=AI_InnervateUp();
			SendAddonMessage("ARI","UPIN:"..InnStatus, "RAID");
			BRezStatus=AI_BRezUp();
			SendAddonMessage("ARI","UPBR:"..BRezStatus, "RAID");
			LifeStatus=AI_IsAlive();
			SendAddonMessage("ARI","UPPL:"..LifeStatus, "RAID");
		end
		AI_UpdateStatusFrame();
	end
	
	if (GetTime()-StatusTimer>5) then
		StatusTimer=GetTime();
		if  (InnStatus~=AI_InnervateUp()) then
			InnStatus=AI_InnervateUp();
			SendAddonMessage("ARI","UPIN:"..InnStatus, "RAID");
		end
		if (BRezStatus~=AI_BRezUp()) then
			BRezStatus=AI_BRezUp();
			SendAddonMessage("ARI","UPBR:"..BRezStatus, "RAID");
		end
		if (LifeStatus~=AI_IsAlive()) then 
			LifeStatus=AI_IsAlive();
			SendAddonMessage("ARI","UPPL:"..LifeStatus, "RAID");
		end
	end
	
	if (event=="PARTY_MEMBERS_CHANGED") then
		--WriteLine(event.."triggered");
		Druids=nil;
		Druids={};
		DAlive=nil;
		DAlive={};
		DInnerv=nil;
		DInnerv={};
		DBRez=nil;
		DBRez={};
		TotalDruids=0;
		SendAddonMessage("ARI","DSSYNC", "RAID");
		AI_UpdateStatusFrame();
	end
	
	if (AI_Redirecting and (GetTime()-AI_RedirSpam)>5) then
		SendChatMessage("No druids available to take the redirect:  NO INNERVATE FOR YOU.","WHISPER",nil,AI_RedirectTo);
		AI_Redirecting=false;
		AI_RedirectTo=nil;
	end
	
	if (strsub(event,1)=="CHAT_MSG_WHISPER") then
		local msg=arg1;
		local plr=arg2;
		if ((GetTime()-AI_LastBuff)>AISpamDelay) and AIAutoBuff==1 and ((string.find(msg,"mow")~=nil) or (string.find(msg,"mark")~=nil) or (string.find(msg,"motw")~=nil) or (string.find(msg,"mdw")~=nil) or (string.find(msg,"wild")~=nil))then
			AI_LastBuff=GetTime();
			Chathooked=true;
			TargetByName(plr, true);
			local dialog = StaticPopup_Show("Buff_Confirm", AI_MARK_NAME,plr);
			if (dialog) then
				dialog.data=plr;
			end
		end
	end
  end
end

function sw(Value)
	if (Value~=nil) then
		return Value;
	else
		return " ";
	end
end

function WriteLine(value)
	DEFAULT_CHAT_FRAME:AddMessage(value);
end

--Function to return true if in raid
function AIRaidID(PlayerName)
	i=1;
	if UnitInRaid("player") then
		--Iterate through the raid searching for the end, or the player.
		while (UnitName("raid"..i)~=PlayerName and UnitName("raid"..i)~=nil) do
			i=i+1;
		end
		if UnitName("raid"..i)==PlayerName then
			return i;
		end
	else
		return 0;
	end
end

--Get the Spell ID of the specified spell
function GetSpellID(SpellName)
	local SpellCount=1;
	local SpellID=0;
	local ReturnName;
	
	while (ReturnName~=SpellName and GetSpellName(SpellCount,BOOKTYPE_SPELL)) do
		ReturnName=GetSpellName(SpellCount,BOOKTYPE_SPELL);
		SpellCount=SpellCount +1;
	end
	if (SpellName == ReturnName) then
		return SpellCount-1;
	else
		WriteLine("Spell "..SpellName.." not found in your spellbook!");
		return 0;
	end
end


function SmartInnervate()
	if (UnitName("target")==nil) then
		DEFAULT_CHAT_FRAME:AddMessage("You have no target selected!  Smart Innervate will not perform checking!");
		CastSpellByName(AI_INNERVATE_NAME);
	else
		if not (UnitIsFriend("player","target") and UnitIsPlayer("target")) then
			DEFAULT_CHAT_FRAME:AddMessage("Only friendly players can be Innervated!");
		else
		InnervateTarget=UnitName("target");
		if (InnerID==0) then
			DEFAULT_CHAT_FRAME:AddMessage("You do not have the spell Innervate!");
		else
			local SStart, SEnd=GetSpellCooldown(InnerID, "SPELL");
			if SStart>0 then
				local TimeRemain=SEnd-(GetTime()-SStart);
				DEFAULT_CHAT_FRAME:AddMessage("Innerv is not up!  "..string.format("%.0f",TimeRemain).." seconds until it's up.");
			else
				
					if (UnitManaMax("target")<200) then
						DEFAULT_CHAT_FRAME:AddMessage("It's generally considered stupid to Innervate a class that doesn't have mana.");
					else
						if (UnitMana("target")>TargetMinMana) then
							DEFAULT_CHAT_FRAME:AddMessage("Target has more than "..TargetMinMana.." Mana.");
						else
							if (CheckInteractDistance("target",4)) then
								local InnervFound=false;
								for i=1,16 do
									local texture=UnitBuff("target",i);
									if (texture~=nil) then
										if (string.find(texture,"Spell_Nature_Lightning")) then
											InnervFound=true;
										end
									end
								end
								if InnervFound then
									DEFAULT_CHAT_FRAME:AddMessage(InnervateTarget.." is already Innervated.");
								else
									--Cast Innervate.
									local FeralForm=false;
									for i=1,4 do
										icon, name, active = GetShapeshiftFormInfo(i);
										if (active~=nil) then
											FeralForm=true;
										end
									end
									if FeralForm then
										DEFAULT_CHAT_FRAME:AddMessage("Cannot Innervate: In Feral.");
									else
										CastSpell(InnerID, "SPELL");
										AI_Alert("Innervating "..InnervateTarget);
										SendChatMessage("Innervating "..InnervateTarget,"WHISPER",nil,InnervateTarget);
									end
								end
								
							else
								DEFAULT_CHAT_FRAME:AddMessage("Out of range to cast Innervate!");
							end
						end
					end
				
			end
		end
		end
	end
end

function DeclineInnervate(InnervateTarget)
if (InnervateTarget) then
	SendChatMessage("Your innervate request has been denied.","WHISPER",nil,InnervateTarget);
end
end

function AutoInnervate(InnervateTarget)
	if (InnervateTarget) then
		TargetByName(InnervateTarget, true);
		if (UnitName("target")~=InnervateTarget) then
			SendChatMessage("Cannot target you for Innervate.","WHISPER",nil,InnervateTarget);
		else
			if ((UnitClass("target")==AIEnablePriestName) and AIEnablePriest==1) or ((UnitClass("target")==AIEnableMageName) and AIEnableMage==1) or ((UnitClass("target")==AIEnableWarlockName) and AIEnableWarlock==1) or ((UnitClass("target")==AIEnableShamanName) and AIEnableShaman==1) or ((UnitClass("target")==AIEnableDruidName) and AIEnableDruid==1)or ((UnitClass("target")==AIEnableHunterName) and AIEnableHunter==1)then
				if (UnitMana("target")>TargetMinMana) then
					SendChatMessage("You can only request an auto Innervate below "..TargetMinMana.." mana.","WHISPER",nil,InnervateTarget);
				else
					if (CheckInteractDistance("target",4)) then
						local InnervFound=false;
						for i=1,16 do
							local texture=UnitBuff("target",i);
							if (texture~=nil) then
								if (string.find(texture,"Spell_Nature_Lightning")) then
									InnervFound=true;
								end
							end
						end
						if InnervFound then
							SendChatMessage("You are already Innervated.","WHISPER",nil,InnervateTarget);
						else
							--Cast Innervate.
							local FeralForm=false;
							for i=1,4 do
								icon, name, active = GetShapeshiftFormInfo(i);
								if (active~=nil) then
									FeralForm=true;
								end
							end
							if FeralForm then
								SendChatMessage("Cannot Innervate: In Feral.","WHISPER",nil,InnervateTarget);
							else
								CastSpellByName(AI_INNERVATE_NAME);
								AI_Alert("Innervating "..InnervateTarget);
								TargetLastTarget();
							end
						end
					else
						SendChatMessage("Out of range to cast Innervate!","WHISPER",nil,InnervateTarget);
					end
				end
			else
				SendChatMessage("Your class cannot auto request innervates.","WHISPER",nil,InnervateTarget);
			end
		end
	end
end

function AutoInnervateRaid(InnervateTarget)
	if (InnervateTarget) then
		TargetByName(InnervateTarget, true);
		if (UnitName("target")~=InnervateTarget) then
			SendChatMessage("Cannot target you for Innervate.","WHISPER",nil,InnervateTarget);
		else
			if (CheckInteractDistance("target",4)) then
				local InnervFound=false;
				for i=1,16 do
					local texture=UnitBuff("target",i);
					if (texture~=nil) then
						if (string.find(texture,"Spell_Nature_Lightning")) then
							InnervFound=true;
						end
					end
				end
				if InnervFound then
					SendChatMessage("You are already Innervated.","WHISPER",nil,InnervateTarget);
				else
					--Cast Innervate.
					local FeralForm=false;
					for i=1,4 do
						icon, name, active = GetShapeshiftFormInfo(i);
						if (active~=nil) then
							FeralForm=true;
						end
					end
					if FeralForm then
						SendChatMessage("Cannot Innervate: In Feral.","WHISPER",nil,InnervateTarget);
					else
						CastSpellByName(AI_INNERVATE_NAME);
						AI_Alert("Innervating "..InnervateTarget);
						TargetLastTarget();
					end
				end
			else
				SendChatMessage("Out of range to cast Innervate!","WHISPER",nil,InnervateTarget);
			end
		end
	end
end